import System
import System.Text.RegularExpressions
import AlbumArtDownloader.Scripts
import util

class AllMusic(AlbumArtDownloader.Scripts.IScript):
	Name as string:
		get: return "AllMusic"
	Version as string:
		get: return "0.1"
	Author as string:
		get: return "Alex Vallat"
	def Search(artist as string, album as string, results as IScriptResults):
		artist = StripCharacters("&.'\";:?!", artist)
		album = StripCharacters("&.'\";:?!", album)

		//Retrieve the search results page
		searchResultsHtml as string = GetPage("https://www.allmusic.com/search/albums/%22" + EncodeUrl(album) + "%22&artist=%22" + EncodeUrl(artist) + "%22");
		
		matches = Regex("<a class=\"album-cover-link[^>]+href=\"(?<url>[^\"]+)\" title=\"(?<title>[^\"]+)\"[^>]+><img[^>]+data-original=\"(?<thumb>[^\"]+)\"", RegexOptions.Singleline | RegexOptions.IgnoreCase).Matches(searchResultsHtml)
		
		results.EstimatedCount = matches.Count
		
		for match as Match in matches:
			thumb = match.Groups["thumb"].Value

			fullSize = thumb
			// Extract full size URL from thumbnail
			fullSizeMatch = Regex("/JPG_170/(?<imgid>[^\\?]+)").Match(thumb)
			if fullSizeMatch.Success:
				fullSize = "https://cps-static.rovicorp.com/3/JPG_1080/" + fullSizeMatch.Groups["imgid"]
			else:
				fullSizeMatch = Regex("release-covers/170/(?<imgid>[^\\?]+)").Match(thumb)
				if fullSizeMatch.Success:
					fullSize = "https://cdn-s3.allmusic.com/release-covers/500/" + fullSizeMatch.Groups["imgid"]
				else:
					fullSizeMatch = Regex("(?<img>.*&f=)2$").Match(thumb)
					if fullSizeMatch.Success:
						fullSize = fullSizeMatch.Groups["img"] + "5"

			results.Add(thumb, match.Groups["title"].Value, "https://www.allmusic.com" + match.Groups["url"].Value, -1, -1, fullSize, CoverType.Front);

    
	def RetrieveFullSizeImage(fullSizeCallbackParameter):
		return fullSizeCallbackParameter;
