# refs: System.Web.Extensions

import System.Text
import System.Text.RegularExpressions
import AlbumArtDownloader.Scripts
import util

class AmazonMp3Com(AlbumArtDownloader.Scripts.IScript):
	Name as string:
		get: return "Amazon MP3 (.com)"
	Version as string:
		get: return "0.3"
	Author as string:
		get: return "Alex Vallat"

	def Search(artist as string, album as string, results as IScriptResults):

		PageEncoding = Encoding.GetEncoding("iso-8859-1")

		artist = StripCharacters("&.'\";:?!", artist)
		album = StripCharacters("&.'\";:?!", album)
		
		url = "https://www.amazon.com/s?rh=n%3A163856011%2Cp_27%3A${EncodeUrl(artist, PageEncoding)}%2Cp_n_feature_browse-bin%3A625150011&sort=relevancerank&keywords=${EncodeUrl(album, PageEncoding)}"
		resultsPage = GetPage(GetPageStream(url, null, true), PageEncoding)
		
		resultsRegex = Regex("<a[^>]+?href\\s*=\\s*\"(?<url>[^\"]+)[^>]+>\\s*<img src\\s*=\\s*\"(?<thumbnail>(?<full>[^\"]+?I/[^.]+)[^\"]+)\"[^>]+?alt=\"(?<title>[^\"]+)\".+?artist-redirect[^>]+>(?<artist>[^<]+)", RegexOptions.Singleline | RegexOptions.IgnoreCase)
		resultsMatches = resultsRegex.Matches(resultsPage)
		
		results.EstimatedCount = resultsMatches.Count
		
		for resultsMatch as Match in resultsMatches:
			url = resultsMatch.Groups["url"].Value
			title = System.Web.HttpUtility.HtmlDecode(resultsMatch.Groups["title"].Value)
			artist = System.Web.HttpUtility.HtmlDecode(resultsMatch.Groups["artist"].Value)
			thumbnail = resultsMatch.Groups["thumbnail"].Value
			full = resultsMatch.Groups["full"].Value + ".jpg"

			results.Add(thumbnail, "${artist} - ${title}", url, 500, 500, full, CoverType.Front)

	def RetrieveFullSizeImage(fullSizeCallbackParameter):
		return fullSizeCallbackParameter