import System
import System.Text.RegularExpressions

import util

class EBay(AlbumArtDownloader.Scripts.IScript):
	Name as string:
		get: return "eBay"
	Version as string:
		get: return "0.1"
	Author as string:
		get: return "Alex Vallat"
	def Search(artist as string, album as string, results as IScriptResults):
		artist = StripCharacters("&.'\";:?!", artist)
		album = StripCharacters("&.'\";:?!", album)
	
		searchResults = GetPage("https://www.ebay.com/sch/i.html?_ipg=25&_sacat=176984&LH_ItemCondition=1000&_nkw="+ EncodeUrl("\"" + artist + "\" \"" + album + "\""))

		matches = Regex("<img class=\"s-item__image-img\" alt=\"(?<title>[^\"]+)\" (?:src=\"[^\"]+\" data-)?src=\"(?<thumbnail>[^\"]+)\".+?<a class=\"s-item__link\" href=\"(?<url>[^\"]+)\"", RegexOptions.Singleline | RegexOptions.IgnoreCase).Matches(searchResults)
		results.EstimatedCount = matches.Count
		
		for match as Match in matches:
			url = match.Groups["url"].Value
			title = match.Groups["title"].Value
			thumbnail = match.Groups["thumbnail"].Value
			image = Regex.Replace(thumbnail, "thumbs/|s-l225\\.jpg", "", RegexOptions.Singleline | RegexOptions.IgnoreCase) + "s-l1600.jpg"

			results.Add(thumbnail, title, url, -1, -1, image, CoverType.Unknown);


	def RetrieveFullSizeImage(fullSizeCallbackParameter):
		return fullSizeCallbackParameter