# refs: System.Web.Extensions

import System
import System.Text.RegularExpressions
import System.Web.Script.Serialization
import AlbumArtDownloader.Scripts
import util

class Yandex(AlbumArtDownloader.Scripts.IScript, ICategorised):
	Name as string:
		get: return "Yandex Music"
	Author as string:
		get: return "Alex Vallat"
	Version as string:
		get: return "0.1"
	Category as string:
		get: return "Russian"
	
	def Search(artist as string, album as string, results as IScriptResults):
		artist = StripCharacters("&.'\";:?!", artist)
		album = StripCharacters("&.'\";:?!", album)

		jsonSearchResults = GetPage("https://music.yandex.ru/handlers/music-search.jsx?text=" + EncodeUrl("\"" + artist + "\" \"" + album + "\"") + "&type=album")
		
		json = JavaScriptSerializer()
		searchResults = json.Deserialize[of Results](jsonSearchResults)
		
		results.EstimatedCount = searchResults.albums.items.Length;
		
		for album in searchResults.albums.items:
			url = "https://music.yandex.ru/album/" + album.id
			title = album.artists[0].name + " - " + album.title
			coverUri = "https://" + album.coverUri.TrimEnd(char('%'));
			results.Add(coverUri + "200x200", title, url, 1000, 1000, coverUri + "m1000x1000", CoverType.Front)

	def RetrieveFullSizeImage(fullSizeCallbackParameter):
		return fullSizeCallbackParameter;

	class Results:
		public albums as Album

		class Album:
			public items as (Item)

			class Item:
				public id as string
				public title as string
				public coverUri as string
				public artists as (Artist)
				
				class Artist:
					public name as string